Revision 44376 - 08/21/2019 07:32 PM - Joaquin del Cerro Murciano

refs #5094, modificaciones para que la funcion FOREING_VALUE se traslade a LEFT JOINs en tablas de BBDD.

History

#1 - 08/21/2019 07:50 PM - Joaquin del Cerro Murciano
- Status changed from New to Fixed

He modificado la implementacion para hacer que las llamadas a la funcion FOREING_VALUE cuando se realicen contra tablas de una BBDD se
traduzcan en anadir al SELECT el LEFT JOIN que toque.

Por ejemplo, cuando tenga sentencias como esta:

SELECT "ID", "NAME", "DESCRIPTION", "TYPE"

FROM "dbo"."test1"

WHERE (( (FOREING_VALUE('TYPE.DESCRIPTION')) LIKE ('A%'") ) AND ( (FOREING_VALUE('PHONE_TYPE.DESCRIPTION")) =
('mobile’) ))

Que la transforme en:
SELECT "ID", "NAME", "dbo"."test1"."DESCRIPTION", "TYPE", "dbo"."TYPES"."DESCRIPTION", "dbo"."PHONE_TYPES"."DESCRIPTION"
FROM "dbo"."test1"
LEFT JOIN "dbo"."TYPES" ON ( ("dbo"."test1"."TYPE") = ("dbo"."TYPES"."ID") )
LEFT JOIN "dbo"."PHONE_TYPES" ON ( ("dbo"."test1"."PHONE_TYPE") = ("dbo"."PHONE_TYPES"."ID") )
WHERE (( ("dbo"."TYPES"."DESCRIPTION") LIKE ('A%') ) AND ( ("dbo"."PHONE_TYPES"."DESCRIPTION") = ('mobile') ))

Ademas los valores de los parametros de la funcion FOREING_VALUE se almacenan en la Feature para ser usados en caso de que sea necesario.

Solo funciona cuando hay una union entre dos tablas, para mas de dos tablas no funcionaria. En ese caso se ejecutaria la funcion FOREING_VALUE
sin ninguna optimizacion. Esto es casos como:
FOREING_VALUE(TYPE.SUBTYPE.DESCRIPTION')

En los que se enlazan tres tablas, no se tratarian de forma especial y no se generarian los LEFT JOINSs.

#2 - 10/17/2019 01:20 PM - Alvaro Anguix
- Status changed from Fixed to Closed
